##Below commands create ICC's design library
# RB : Set it to the top of the nanorv32 database for now
set LIB_PATH                          $env(LIB_PATH)
set USE_RVT                           $env(USE_RVT)
set EXIT_WHEN_DONE                    $env(EXIT_WHEN_DONE)


set MW_REFERENCE_LIB_DIRS {}
lappend search_path $LIB_PATH/liberty
if { $USE_RVT == 1 } {
    set target_library "tcbn55lpbwp7t_1V0SS-40C.db"
    set MW_DESIGN_LIBRARY "NRV32.mw"
    lappend MW_REFERENCE_LIB_DIRS $LIB_PATH/milkyway/tcbn55lpbwp7t_LIB
} else {
    set target_library "tcbn55lpbwp7thvt_1V0SS-40C.db"
    set MW_DESIGN_LIBRARY "NRV32hvt.mw"
    lappend MW_REFERENCE_LIB_DIRS $LIB_PATH/milkyway/tcbn55lpbwp7thvt_LIB
    #lappend MW_REFERENCE_LIB_DIRS $LIB_PATH/tsmc55nm_ulp/technology/lib_ip/tcbn55lpbwp7thvt/milkyway/tcbn55lpbwp7thvt_LIB
    #lappend MW_REFERENCE_LIB_DIRS /pro/quark4413/work/hes1/nanorv32-ik-clean/ips/imported/nanorv32/tsmc55nm_ulp/technology/lib_ip/tcbn55lpbwp7t/milkyway/tcbn55lpbwp7thvt_LIB

}

set link_library "$target_library "
set mw_logic0_net VSS
set mw_logic1_net VDD
set_tlu_plus_files -max_tluplus /n/library/tsmc/55n/libraries/tcbn55lpbwp7t/200b/milkyway/tcbn55lpbwp7t_200a/techfiles/tluplus/cln55lp_1p05m_and_28k_alrdl_3x1z_cworst.tluplus -min_tluplus /n/library/tsmc/55n/libraries/tcbn55lpbwp7t/200b/milkyway/tcbn55lpbwp7t_200a/techfiles/tluplus/cln55lp_1p05m_and_28k_alrdl_3x1z_rcbest.tluplus -tech2itf_map /n/library/tsmc/55n/libraries/tcbn55lpbwp7t/200b/milkyway/tcbn55lpbwp7t_200a/techfiles/tluplus/star.map_5M

##Below commands create Milkway database
set TECH_FILE /n/caduser/tools/icc/techfiles/TSMC/tsmc55/CLN55S_5M_3X1Z.20b/tsmcn55_5lmT1_nordic_v1.1.tf


file mkdir "reports"

extend_mw_layers

# Only the first time
if {![file exists $MW_DESIGN_LIBRARY] } {
    create_mw_lib -tech $TECH_FILE -mw_reference_library $MW_REFERENCE_LIB_DIRS $MW_DESIGN_LIBRARY
}


#Open new created library
open_mw_lib $MW_DESIGN_LIBRARY


read_verilog ../../synt/design_compiler/results/nanorv32_regfile.mapped.v
read_sdc ../../synt/design_compiler/results/nanorv32_regfile.mapped.sdc


source relplace.tcl

create_floorplan -control_type aspect_ratio -core_utilization 0.7

place_opt -effort medium

set_rp_group_options -cts_option fixed_placement \
   [get_rp_groups *]

clock_opt -clock_trees {clk}

set_rp_group_options -route_opt_option fixed_placement \
   [get_rp_groups *]

route_zrt_global -effort minimum
set_rp_group_options -route_opt_option fixed_placement \
   [get_rp_groups *]
route_zrt_track
set_rp_group_options -route_opt_option fixed_placement \
   [get_rp_groups *]
route_zrt_detail

redirect -tee -file reports/timing_relplace.rpt {report_timing -max_paths 50}
redirect -tee -file reports/power_relplace.rpt {report_power}
redirect -tee -file reports/area_relplace.rpt {report_area}

write_verilog nanorv32_regfile.routed.v
write  -format ddc  -hierarchy   -output {nanorv32_regfile.routed.ddc}
write_parasitics -output nanorv32_regfile.routed.spef
write_sdf  nanorv32_regfile.routed.sdf
write_def -output nanorv32_regfile.routed.def

if {$EXIT_WHEN_DONE == 3} {
    exit
}
