import svgwrite
from svgwrite import cm, mm
dwg = svgwrite.Drawing('test.svg', profile='tiny')
dwg.add(dwg.line((0, 0), (10, 0), stroke=svgwrite.rgb(10, 10, 16, '%')))
dwg.add(dwg.text('Test', insert=(0, 0.2), fill='red'))
dwg.save()

class Relative_position:
        def __init__(self,position):
            if (position == "right"):
                self.x_adjust = 1
                self.y_adjust = 0
            elif (position == "left"):
                self.x_adjust = -1
                self.y_adjust = 0
            elif (position == "under"):
                self.x_adjust = 0
                self.y_adjust = -1
            elif (position == "over"):
                self.x_adjust = 0
                self.y_adjust = 1
            elif (position == "TLTL"):
                self.x_adjust = -1
                self.y_adjust = 1
            elif (position == "TLTR"):
                self.x_adjust = 0
                self.y_adjust = 1
            elif (position == "TLBL"):
                self.x_adjust = -1
                self.y_adjust = 0
            elif (position == "TRTL"):
                self.x_adjust = 0
                self.y_adjust = 1
            elif (position == "TRTR"):
                self.x_adjust = 1
                self.y_adjust = 1
            elif (position == "TRBR"):
                self.x_adjust = 1
                self.y_adjust = 0
            elif (position == "BLTL"):
                self.x_adjust = -1
                self.y_adjust = 0
            elif (position == "BLBL"):
                self.x_adjust = -1
                self.y_adjust = -1
            elif (position == "BLBR"):
                self.x_adjust = 0
                self.y_adjust = -1
            elif (position == "BRTR"):
                self.x_adjust = 1
                self.y_adjust = 0
            elif (position == "BRBL"):
                self.x_adjust = 0
                self.y_adjust = -1
            elif (position == "BRBR"):
                self.x_adjust = 1
                self.y_adjust = -1
            else:
                self.x_adjust = 0
                self.y_adjust = 0


class Cell:
        def __init__(self,name,height,width):
            self.name = name
            self.height = height
            self.width = width
            self.x = None
            self.y = None

        def relative_place(self,neighboor,position):
            self.x = neighboor.x + position.x_adjust
            self.y = neighboor.y + position.y_adjust

class Bit:
        def __init__(self,ffname):
            self.flop = Cell(name=ffname,height=5,width=50)
            self.flop.x=0
            self.flop.y=0
            self.mux = Cell(name="Mux",height=10,width=10)
            self.mux.relative_place(self.flop,Relative_position("right"))
        def printBit(self):
            dwg = svgwrite.Drawing(filename="test.svg")
            shapes = dwg.add(dwg.g(id='shapes', fill='red'))
            print("self.flop.x: " + str(self.flop.x) + " self.mux.x: "+ str(self.mux.x)+" self.flop.y: " + str(self.flop.y) + " self.mux.y: " + str(self.mux.y))
            flop_xpos = 10*self.flop.x * mm
            flop_ypos = -10*self.flop.y * mm
            mux_xpos =  (10*self.mux.x  + self.flop.width-10)*mm
            mux_ypos = (-10*self.mux.y  )*mm
            text_flop_xpos = (10*self.flop.x+4) * mm
            text_flop_ypos = (-10*self.flop.y +5)* mm
            text_mux_xpos = (10*self.mux.x  + self.flop.width-8)*mm
            text_mux_ypos = (-10*self.mux.y +5)*mm
            shapes.add(dwg.rect(insert=(flop_xpos,flop_ypos), size=(self.flop.width * mm, self.flop.height * mm),fill='white', stroke='red', stroke_width=3))
            shapes.add(dwg.rect(insert=(mux_xpos,mux_ypos ), size=(self.mux.width * mm, self.mux.height * mm), fill='white', stroke='red', stroke_width=3))
            g = dwg.g(style="font-size:12;font-family:Comic Sans MS, Arial;font-weight:bold;font-style: oblique;stroke: black;stroke - width: 1;fill: black")
            g.add(dwg.text(self.flop.name, insert=(text_flop_xpos,text_flop_ypos )))  # settings are valid for all text added to 'g'
            g.add(dwg.text(self.mux.name, insert=(text_mux_xpos,text_mux_ypos )))
            dwg.add(g)
            dwg.save()
        def relative_place(self,neighboor,position):
            if (position == "right"):
                self.flop.x = neighboor.mux.x + 1
                self.flop.y = neighboor.mux.y
                self.mux.x = self.flop.x +1
                self.mux.y = self.flop.y
            elif (position == "left"):
                self.flop.x = neighboor.flop.x-2
                self.flop.y = neighboor.flop.y
                self.mux.x = neighboor.flop.x-1
                self.mux.y = neighboor.flop.y
            elif (position == "under"):
                self.flop.x = neighboor.flop.x
                self.flop.y = neighboor.flop.y + 1
                self.mux.x = neighboor.mux.x
                self.mux.y = neighboor.mux.y +1
            elif (position == "over"):
                self.flop.x = neighboor.flop.x
                self.flop.y = neighboor.flop.y + 1
                self.mux.x = neighboor.mux.x
                self.mux.y = neighboor.mux.y +1
            elif (position == "TLTL"):
                self.flop.x = neighboor.flop.x - 2
                self.flop.y = neighboor.flop.y +1
                self.mux.x = neighboor.mux.x - 2
                self.mux.y = neighboor.mux.y +1
            elif (position == "TLTR"):
                self.flop.x = neighboor.flop.x
                self.flop.y = neighboor.flop.y + 1
                self.mux.x = neighboor.mux.x
                self.mux.y = neighboor.mux.y + 1
            elif (position == "TLBL"):
                self.flop.x = neighboor.flop.x - 2
                self.flop.y = neighboor.flop.y
                self.mux.x = neighboor.mux.x - 2
                self.mux.y = neighboor.mux.y
            elif (position == "TRTL"):
                self.flop.x = neighboor.flop.x
                self.flop.y = neighboor.flop.y + 1
                self.mux.x = neighboor.mux.x
                self.mux.y = neighboor.mux.y + 1
            elif (position == "TRTR"):
                self.flop.x = neighboor.flop.x + 2
                self.flop.y = neighboor.flop.y + 1
                self.mux.x = neighboor.mux.x + 2
                self.mux.y = neighboor.mux.y + 1
            elif (position == "TRBR"):
                self.flop.x = neighboor.flop.x + 2
                self.flop.y = neighboor.flop.y
                self.mux.x = neighboor.mux.x + 2
                self.mux.y = neighboor.mux.y
            elif (position == "BLTL"):
                self.flop.x = neighboor.flop.x - 2
                self.flop.y = neighboor.flop.y
                self.mux.x = neighboor.mux.x - 2
                self.mux.y = neighboor.mux.y
            elif (position == "BLBL"):
                self.flop.x = neighboor.flop.x - 2
                self.flop.y = neighboor.flop.y - 1
                self.mux.x = neighboor.mux.x - 2
                self.mux.y = neighboor.mux.y - 1
            elif (position == "BLBR"):
                self.flop.x = neighboor.flop.x
                self.flop.y = neighboor.flop.y - 1
                self.mux.x = neighboor.mux.x
                self.mux.y = neighboor.mux.y - 1
            elif (position == "BRTR"):
                self.flop.x = neighboor.flop.x + 2
                self.flop.y = neighboor.flop.y
                self.mux.x = neighboor.mux.x + 2
                self.mux.y = neighboor.mux.y
            elif (position == "BRBL"):
                self.flop.x = neighboor.flop.x
                self.flop.y = neighboor.flop.y - 1
                self.mux.x = neighboor.mux.x
                self.mux.y = neighboor.mux.y - 1
            elif (position == "BRBR"):
                self.flop.x = neighboor.flop.x + 2
                self.flop.y = neighboor.flop.y - 1
                self.mux.x = neighboor.mux.x + 2
                self.mux.y = neighboor.mux.y - 1
            else:
                self.flop.x = neighboor.flop.x
                self.flop.y = neighboor.flop.y
                self.mux.x = neighboor.mux.x
                self.mux.y = neighboor.mux.y

class FourBits:
        def __init__(self):
            self.bit0 = Bit("FF")
            self.bit1 = Bit("FF")
            self.bit2 = Bit("FF")
            self.bit3 = Bit("FF")
            self.cg = Cell(name="CG", height=10, width=10)
            self.cg.x = 0
            self.cg.y = 0
            self.bit0.flop.relative_place(self.cg,Relative_position("under"))
            self.bit0.mux.relative_place(self.bit0.flop,Relative_position("right"))
            self.bit1.relative_place(self.bit0,"under")
            self.bit2.relative_place(self.bit1, "under")
            self.bit3.relative_place(self.bit2, "under")

        def printBits(self):
            dwg = svgwrite.Drawing(filename="test.svg")
            shapes = dwg.add(dwg.g(id='shapes', fill='red'))


            shapes.add(dwg.rect(insert=(self.cg.x*10*mm, self.cg.y*10*mm), size=(self.cg.width * mm, self.cg.height * mm), fill='white', stroke='black', stroke_width=3))#cg
            shapes.add(dwg.rect(insert=(10 * self.bit0.flop.x * mm, -10 * self.bit0.flop.y * mm), size=(self.bit0.flop.width * mm, self.bit0.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff0
            shapes.add(dwg.rect(insert=((10 * self.bit0.mux.x + self.bit0.flop.width - 10) * mm, (-10 * self.bit0.mux.y) * mm), size=(self.bit0.mux.width * mm, self.bit0.mux.height * mm), fill='white', stroke='black', stroke_width=3))#mux0
            shapes.add(dwg.rect(insert=(10 * self.bit1.flop.x * mm, -10 * self.bit1.flop.y * mm), size=(self.bit1.flop.width * mm, self.bit1.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff1
            shapes.add(dwg.rect(insert=((10 * self.bit1.mux.x + self.bit1.flop.width - 10) * mm, (-10 * self.bit1.mux.y) * mm), size=(self.bit1.mux.width * mm, self.bit1.mux.height * mm),fill='white', stroke='black', stroke_width=3))##mux1
            shapes.add(dwg.rect(insert=(10 * self.bit2.flop.x * mm, -10 * self.bit2.flop.y * mm), size=(self.bit2.flop.width * mm, self.bit2.flop.height * mm),fill='white', stroke='black', stroke_width=3))#ff2
            shapes.add(dwg.rect(insert=((10 * self.bit2.mux.x + self.bit2.flop.width - 10) * mm, (-10 * self.bit2.mux.y) * mm), size=(self.bit2.mux.width * mm, self.bit2.mux.height * mm), fill='white', stroke='black', stroke_width=3))#mux2
            shapes.add(dwg.rect(insert=(10 * self.bit3.flop.x * mm, -10 * self.bit3.flop.y * mm), size=(self.bit3.flop.width * mm, self.bit3.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff3
            shapes.add(dwg.rect(insert=((10 * self.bit3.mux.x + self.bit3.flop.width - 10) * mm, (-10 * self.bit3.mux.y) * mm), size=(self.bit3.mux.width * mm, self.bit3.mux.height * mm), fill='white', stroke='black', stroke_width=3))#mux3
            g = dwg.g(
                style="font-size:12;font-family:Comic Sans MS, Arial;font-weight:bold;font-style: oblique;stroke: black;stroke - width: 1;fill: black")
            g.add(dwg.text(self.cg.name, insert=((self.cg.x*10+3)*mm,(-10* self.cg.y +6)*mm )))
            g.add(dwg.text(self.bit0.flop.name,insert=((10 * self.bit0.flop.x + 4) * mm, (-10 * self.bit0.flop.y + 5) * mm)))  # settings are valid for all text added to 'g'
            g.add(dwg.text(self.bit0.mux.name, insert=((10 * self.bit0.mux.x + self.bit0.flop.width - 8) * mm, (-10 * self.bit0.mux.y + 5) * mm)))
            g.add(dwg.text(self.bit1.flop.name,insert=((10 * self.bit1.flop.x + 4) * mm, (-10 * self.bit1.flop.y + 5) * mm)))  # settings are valid for all text added to 'g'
            g.add(dwg.text(self.bit1.mux.name, insert=((10 * self.bit1.mux.x + self.bit1.flop.width - 8) * mm, (-10 * self.bit1.mux.y + 5) * mm)))
            g.add(dwg.text(self.bit2.flop.name,insert=((10 * self.bit2.flop.x + 4) * mm, (-10 * self.bit2.flop.y + 5) * mm)))  # settings are valid for all text added to 'g'
            g.add(dwg.text(self.bit2.mux.name, insert=((10 * self.bit2.mux.x + self.bit2.flop.width - 8) * mm, (-10 * self.bit2.mux.y + 5) * mm)))
            g.add(dwg.text(self.bit3.flop.name,insert=((10 * self.bit3.flop.x + 4) * mm, (-10 * self.bit3.flop.y + 5) * mm)))  # settings are valid for all text added to 'g'
            g.add(dwg.text(self.bit3.mux.name, insert=((10 * self.bit3.mux.x + self.bit3.flop.width - 8) * mm, (-10 * self.bit3.mux.y + 5) * mm)))
            dwg.add(g)
            dwg.save()


class Register:
        def __init__(self,pos,xpos):
            number = str(pos)
            self.bit0 = Bit("regfile_reg_"+number+"__0_")
            self.bit1 = Bit("regfile_reg_"+number+"__1_")
            self.bit2 = Bit("regfile_reg_"+number+"__2_")
            self.bit3 = Bit("regfile_reg_"+number+"__3_")
            self.bit4 = Bit("regfile_reg_"+number+"__4_")
            self.bit5 = Bit("regfile_reg_"+number+"__5_")
            self.bit6 = Bit("regfile_reg_"+number+"__6_")
            self.bit7 = Bit("regfile_reg_"+number+"__7_")
            self.bit8 = Bit("regfile_reg_"+number+"__8_")
            self.bit9 = Bit("regfile_reg_"+number+"__9_")
            self.bit10 = Bit("regfile_reg_"+number+"__10_")
            self.bit11 = Bit("regfile_reg_"+number+"__11_")
            self.bit12 = Bit("regfile_reg_"+number+"__12_")
            self.bit13 = Bit("regfile_reg_"+number+"__13_")
            self.bit14 = Bit("regfile_reg_"+number+"__14_")
            self.bit15 = Bit("regfile_reg_"+number+"__15_")
            self.bit16 = Bit("regfile_reg_"+number+"__16_")
            self.bit17 = Bit("regfile_reg_"+number+"__17_")
            self.bit18 = Bit("regfile_reg_"+number+"__18_")
            self.bit19 = Bit("regfile_reg_"+number+"__19_")
            self.bit20 = Bit("regfile_reg_"+number+"__20_")
            self.bit21 = Bit("regfile_reg_"+number+"__21_")
            self.bit22 = Bit("regfile_reg_"+number+"__22_")
            self.bit23 = Bit("regfile_reg_"+number+"__23_")
            self.bit24 = Bit("regfile_reg_"+number+"__24_")
            self.bit25 = Bit("regfile_reg_"+number+"__25_")
            self.bit26 = Bit("regfile_reg_"+number+"__26_")
            self.bit27 = Bit("regfile_reg_"+number+"__27_")
            self.bit28 = Bit("regfile_reg_"+number+"__28_")
            self.bit29 = Bit("regfile_reg_"+number+"__29_")
            self.bit30 = Bit("regfile_reg_"+number+"__30_")
            self.bit31 = Bit("regfile_reg_"+number+"__31_")
            self.bit0.flop.x = xpos
            self.bit0.flop.y = 0
            self.bit0.mux.relative_place(self.bit0.flop,Relative_position("right"))
            self.bit1.relative_place(self.bit0,"under")
            self.bit2.relative_place(self.bit1, "under")
            self.bit3.relative_place(self.bit2, "under")
            self.bit4.relative_place(self.bit3,"under")
            self.bit5.relative_place(self.bit4, "under")
            self.bit6.relative_place(self.bit5, "under")
            self.bit7.relative_place(self.bit6,"under")
            self.bit8.relative_place(self.bit7, "under")
            self.bit9.relative_place(self.bit8, "under")
            self.bit10.relative_place(self.bit9,"under")
            self.bit11.relative_place(self.bit10, "under")
            self.bit12.relative_place(self.bit11, "under")
            self.bit13.relative_place(self.bit12,"under")
            self.bit14.relative_place(self.bit13, "under")
            self.bit15.relative_place(self.bit14, "under")
            self.bit16.relative_place(self.bit15,"under")
            self.bit17.relative_place(self.bit16, "under")
            self.bit18.relative_place(self.bit17, "under")
            self.bit19.relative_place(self.bit18,"under")
            self.bit20.relative_place(self.bit19, "under")
            self.bit21.relative_place(self.bit20, "under")
            self.bit22.relative_place(self.bit21,"under")
            self.bit23.relative_place(self.bit22, "under")
            self.bit24.relative_place(self.bit23, "under")
            self.bit25.relative_place(self.bit24, "under")
            self.bit26.relative_place(self.bit25, "under")
            self.bit27.relative_place(self.bit26,"under")
            self.bit28.relative_place(self.bit27, "under")
            self.bit29.relative_place(self.bit28, "under")
            self.bit30.relative_place(self.bit29,"under")
            self.bit31.relative_place(self.bit30, "under")
        def printBits(self):
                dwg = svgwrite.Drawing(filename="test.svg")
                shapes = dwg.add(dwg.g(id='shapes', fill='red'))
                
                shapes.add(dwg.rect(insert=(10 * self.bit0.flop.x * mm, 5 * self.bit0.flop.y * mm), size=(self.bit0.flop.width * mm, self.bit0.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff0
                shapes.add(dwg.rect(insert=(10 * self.bit1.flop.x * mm, 5 * self.bit1.flop.y * mm), size=(self.bit1.flop.width * mm, self.bit1.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff1
                shapes.add(dwg.rect(insert=(10 * self.bit2.flop.x * mm, 5 * self.bit2.flop.y * mm), size=(self.bit2.flop.width * mm, self.bit2.flop.height * mm),fill='white', stroke='black', stroke_width=3))#ff2
                shapes.add(dwg.rect(insert=(10 * self.bit3.flop.x * mm, 5 * self.bit3.flop.y * mm), size=(self.bit3.flop.width * mm, self.bit3.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff3
                shapes.add(dwg.rect(insert=(10 * self.bit4.flop.x * mm, 5 * self.bit4.flop.y * mm), size=(self.bit4.flop.width * mm, self.bit4.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff4
                shapes.add(dwg.rect(insert=(10 * self.bit5.flop.x * mm, 5 * self.bit5.flop.y * mm), size=(self.bit5.flop.width * mm, self.bit5.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff5
                shapes.add(dwg.rect(insert=(10 * self.bit6.flop.x * mm, 5 * self.bit6.flop.y * mm), size=(self.bit6.flop.width * mm, self.bit6.flop.height * mm),fill='white', stroke='black', stroke_width=3))#ff6
                shapes.add(dwg.rect(insert=(10 * self.bit7.flop.x * mm, 5 * self.bit7.flop.y * mm), size=(self.bit7.flop.width * mm, self.bit7.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff7
                shapes.add(dwg.rect(insert=(10 * self.bit8.flop.x * mm, 5 * self.bit8.flop.y * mm), size=(self.bit8.flop.width * mm, self.bit8.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff8
                shapes.add(dwg.rect(insert=(10 * self.bit9.flop.x * mm, 5 * self.bit9.flop.y * mm), size=(self.bit9.flop.width * mm, self.bit9.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff9
                shapes.add(dwg.rect(insert=(10 * self.bit10.flop.x * mm, 5 * self.bit10.flop.y * mm), size=(self.bit10.flop.width * mm, self.bit10.flop.height * mm),fill='white', stroke='black', stroke_width=3))#ff10
                shapes.add(dwg.rect(insert=(10 * self.bit11.flop.x * mm, 5 * self.bit11.flop.y * mm), size=(self.bit11.flop.width * mm, self.bit11.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff11
                shapes.add(dwg.rect(insert=(10 * self.bit12.flop.x * mm, 5 * self.bit12.flop.y * mm), size=(self.bit12.flop.width * mm, self.bit12.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff12
                shapes.add(dwg.rect(insert=(10 * self.bit13.flop.x * mm, 5 * self.bit13.flop.y * mm), size=(self.bit13.flop.width * mm, self.bit13.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff1
                shapes.add(dwg.rect(insert=(10 * self.bit14.flop.x * mm, 5 * self.bit14.flop.y * mm), size=(self.bit14.flop.width * mm, self.bit14.flop.height * mm),fill='white', stroke='black', stroke_width=3))#ff14
                shapes.add(dwg.rect(insert=(10 * self.bit15.flop.x * mm, 5 * self.bit15.flop.y * mm), size=(self.bit15.flop.width * mm, self.bit15.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff15
                shapes.add(dwg.rect(insert=(10 * self.bit16.flop.x * mm, 5 * self.bit16.flop.y * mm), size=(self.bit16.flop.width * mm, self.bit16.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff16
                shapes.add(dwg.rect(insert=(10 * self.bit17.flop.x * mm, 5 * self.bit17.flop.y * mm), size=(self.bit17.flop.width * mm, self.bit17.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff17
                shapes.add(dwg.rect(insert=(10 * self.bit18.flop.x * mm, 5 * self.bit18.flop.y * mm), size=(self.bit18.flop.width * mm, self.bit18.flop.height * mm),fill='white', stroke='black', stroke_width=3))#ff18
                shapes.add(dwg.rect(insert=(10 * self.bit19.flop.x * mm, 5 * self.bit19.flop.y * mm), size=(self.bit19.flop.width * mm, self.bit19.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff19
                shapes.add(dwg.rect(insert=(10 * self.bit20.flop.x * mm, 5 * self.bit20.flop.y * mm), size=(self.bit20.flop.width * mm, self.bit20.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff20
                shapes.add(dwg.rect(insert=(10 * self.bit21.flop.x * mm, 5 * self.bit21.flop.y * mm), size=(self.bit21.flop.width * mm, self.bit21.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff21
                shapes.add(dwg.rect(insert=(10 * self.bit22.flop.x * mm, 5 * self.bit22.flop.y * mm), size=(self.bit22.flop.width * mm, self.bit22.flop.height * mm),fill='white', stroke='black', stroke_width=3))#ff22
                shapes.add(dwg.rect(insert=(10 * self.bit23.flop.x * mm, 5 * self.bit23.flop.y * mm), size=(self.bit23.flop.width * mm, self.bit23.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff23
                shapes.add(dwg.rect(insert=(10 * self.bit24.flop.x * mm, 5 * self.bit24.flop.y * mm), size=(self.bit24.flop.width * mm, self.bit24.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff24
                shapes.add(dwg.rect(insert=(10 * self.bit25.flop.x * mm, 5 * self.bit25.flop.y * mm), size=(self.bit25.flop.width * mm, self.bit25.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff25
                shapes.add(dwg.rect(insert=(10 * self.bit26.flop.x * mm, 5 * self.bit26.flop.y * mm), size=(self.bit26.flop.width * mm, self.bit26.flop.height * mm),fill='white', stroke='black', stroke_width=3))#ff26
                shapes.add(dwg.rect(insert=(10 * self.bit27.flop.x * mm, 5 * self.bit27.flop.y * mm), size=(self.bit27.flop.width * mm, self.bit27.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff27
                shapes.add(dwg.rect(insert=(10 * self.bit28.flop.x * mm, 5 * self.bit28.flop.y * mm), size=(self.bit28.flop.width * mm, self.bit28.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff28
                shapes.add(dwg.rect(insert=(10 * self.bit29.flop.x * mm, 5 * self.bit29.flop.y * mm), size=(self.bit29.flop.width * mm, self.bit29.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff29
                shapes.add(dwg.rect(insert=(10 * self.bit30.flop.x * mm, 5 * self.bit30.flop.y * mm), size=(self.bit30.flop.width * mm, self.bit30.flop.height * mm),fill='white', stroke='black', stroke_width=3))#ff30
                shapes.add(dwg.rect(insert=(10 * self.bit31.flop.x * mm, 5 * self.bit31.flop.y * mm), size=(self.bit31.flop.width * mm, self.bit31.flop.height * mm), fill='white', stroke='black', stroke_width=3))#ff31
                g = dwg.g(
                style="font-size:12;font-family:Comic Sans MS, Arial;font-weight:bold;font-style: oblique;stroke: black;stroke - width: 1;fill: black")
                g.add(dwg.text(self.bit0.flop.name,insert=((10 * self.bit0.flop.x + 4) * mm, (5 * self.bit0.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit1.flop.name,insert=((10 * self.bit1.flop.x + 4) * mm, (5 * self.bit1.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit2.flop.name,insert=((10 * self.bit2.flop.x + 4) * mm, (5 * self.bit2.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit3.flop.name,insert=((10 * self.bit3.flop.x + 4) * mm, (5 * self.bit3.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit4.flop.name,insert=((10 * self.bit4.flop.x + 4) * mm, (5 * self.bit4.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit5.flop.name,insert=((10 * self.bit5.flop.x + 4) * mm, (5 * self.bit5.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit6.flop.name,insert=((10 * self.bit6.flop.x + 4) * mm, (5 * self.bit6.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit7.flop.name,insert=((10 * self.bit7.flop.x + 4) * mm, (5 * self.bit7.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit8.flop.name,insert=((10 * self.bit8.flop.x + 4) * mm, (5 * self.bit8.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit9.flop.name,insert=((10 * self.bit9.flop.x + 4) * mm, (5 * self.bit9.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit10.flop.name,insert=((10 * self.bit10.flop.x + 4) * mm, (5 * self.bit10.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit11.flop.name,insert=((10 * self.bit11.flop.x + 4) * mm, (5 * self.bit11.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit12.flop.name,insert=((10 * self.bit12.flop.x + 4) * mm, (5 * self.bit12.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit13.flop.name,insert=((10 * self.bit13.flop.x + 4) * mm, (5 * self.bit13.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit14.flop.name,insert=((10 * self.bit14.flop.x + 4) * mm, (5 * self.bit14.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit15.flop.name,insert=((10 * self.bit15.flop.x + 4) * mm, (5 * self.bit15.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit16.flop.name,insert=((10 * self.bit16.flop.x + 4) * mm, (5 * self.bit16.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit17.flop.name,insert=((10 * self.bit17.flop.x + 4) * mm, (5 * self.bit17.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit18.flop.name,insert=((10 * self.bit18.flop.x + 4) * mm, (5 * self.bit18.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit19.flop.name,insert=((10 * self.bit19.flop.x + 4) * mm, (5 * self.bit19.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit20.flop.name,insert=((10 * self.bit20.flop.x + 4) * mm, (5 * self.bit20.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit21.flop.name,insert=((10 * self.bit21.flop.x + 4) * mm, (5 * self.bit21.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit22.flop.name,insert=((10 * self.bit22.flop.x + 4) * mm, (5 * self.bit22.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit23.flop.name,insert=((10 * self.bit23.flop.x + 4) * mm, (5 * self.bit23.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit24.flop.name,insert=((10 * self.bit24.flop.x + 4) * mm, (5 * self.bit24.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit25.flop.name,insert=((10 * self.bit25.flop.x + 4) * mm, (5 * self.bit25.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit26.flop.name,insert=((10 * self.bit26.flop.x + 4) * mm, (5 * self.bit26.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit27.flop.name,insert=((10 * self.bit27.flop.x + 4) * mm, (5 * self.bit27.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit28.flop.name,insert=((10 * self.bit28.flop.x + 4) * mm, (5 * self.bit28.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit29.flop.name,insert=((10 * self.bit29.flop.x + 4) * mm, (5 * self.bit29.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit30.flop.name,insert=((10 * self.bit30.flop.x + 4) * mm, (5 * self.bit30.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'
                g.add(dwg.text(self.bit31.flop.name,insert=((10 * self.bit31.flop.x + 4) * mm, (5 * self.bit31.flop.y + 3.5) * mm)))  # settings are valid for all text added to 'g'

                dwg.add(g)
                dwg.save()
        def writeRpGroup(self,file,rp_group):
                #f = open(file,'w')
                f.write(rp_group+self.bit0.flop.name+" -column "+str(self.bit0.flop.x)+" -row "+str(self.bit0.flop.y)+" \n")
                f.write(rp_group+self.bit1.flop.name+" -column "+str(self.bit1.flop.x)+" -row "+str(self.bit1.flop.y)+" \n")
                f.write(rp_group+self.bit2.flop.name+" -column "+str(self.bit2.flop.x)+" -row "+str(self.bit2.flop.y)+" \n")
                f.write(rp_group+self.bit3.flop.name+" -column "+str(self.bit3.flop.x)+" -row "+str(self.bit3.flop.y)+" \n")
                f.write(rp_group+self.bit4.flop.name+" -column "+str(self.bit4.flop.x)+" -row "+str(self.bit4.flop.y)+" \n")
                f.write(rp_group+self.bit5.flop.name+" -column "+str(self.bit5.flop.x)+" -row "+str(self.bit5.flop.y)+" \n")
                f.write(rp_group+self.bit6.flop.name+" -column "+str(self.bit6.flop.x)+" -row "+str(self.bit6.flop.y)+" \n")
                f.write(rp_group+self.bit7.flop.name+" -column "+str(self.bit7.flop.x)+" -row "+str(self.bit7.flop.y)+" \n")
                f.write(rp_group+self.bit8.flop.name+" -column "+str(self.bit8.flop.x)+" -row "+str(self.bit8.flop.y)+" \n")
                f.write(rp_group+self.bit9.flop.name+" -column "+str(self.bit9.flop.x)+" -row "+str(self.bit9.flop.y)+" \n")
                f.write(rp_group+self.bit10.flop.name+" -column "+str(self.bit10.flop.x)+" -row "+str(self.bit10.flop.y)+" \n")
                f.write(rp_group+self.bit11.flop.name+" -column "+str(self.bit11.flop.x)+" -row "+str(self.bit11.flop.y)+" \n")
                f.write(rp_group+self.bit12.flop.name+" -column "+str(self.bit12.flop.x)+" -row "+str(self.bit12.flop.y)+" \n")
                f.write(rp_group+self.bit13.flop.name+" -column "+str(self.bit13.flop.x)+" -row "+str(self.bit13.flop.y)+" \n")
                f.write(rp_group+self.bit14.flop.name+" -column "+str(self.bit14.flop.x)+" -row "+str(self.bit14.flop.y)+" \n")
                f.write(rp_group+self.bit15.flop.name+" -column "+str(self.bit15.flop.x)+" -row "+str(self.bit15.flop.y)+" \n")
                f.write(rp_group+self.bit16.flop.name+" -column "+str(self.bit16.flop.x)+" -row "+str(self.bit16.flop.y)+" \n")
                f.write(rp_group+self.bit17.flop.name+" -column "+str(self.bit17.flop.x)+" -row "+str(self.bit17.flop.y)+" \n")
                f.write(rp_group+self.bit18.flop.name+" -column "+str(self.bit18.flop.x)+" -row "+str(self.bit18.flop.y)+" \n")
                f.write(rp_group+self.bit19.flop.name+" -column "+str(self.bit19.flop.x)+" -row "+str(self.bit19.flop.y)+" \n")
                f.write(rp_group+self.bit20.flop.name+" -column "+str(self.bit20.flop.x)+" -row "+str(self.bit20.flop.y)+" \n")
                f.write(rp_group+self.bit21.flop.name+" -column "+str(self.bit21.flop.x)+" -row "+str(self.bit21.flop.y)+" \n")
                f.write(rp_group+self.bit22.flop.name+" -column "+str(self.bit22.flop.x)+" -row "+str(self.bit22.flop.y)+" \n")
                f.write(rp_group+self.bit23.flop.name+" -column "+str(self.bit23.flop.x)+" -row "+str(self.bit23.flop.y)+" \n")
                f.write(rp_group+self.bit24.flop.name+" -column "+str(self.bit24.flop.x)+" -row "+str(self.bit24.flop.y)+" \n")
                f.write(rp_group+self.bit25.flop.name+" -column "+str(self.bit25.flop.x)+" -row "+str(self.bit25.flop.y)+" \n")
                f.write(rp_group+self.bit26.flop.name+" -column "+str(self.bit26.flop.x)+" -row "+str(self.bit26.flop.y)+" \n")
                f.write(rp_group+self.bit27.flop.name+" -column "+str(self.bit27.flop.x)+" -row "+str(self.bit27.flop.y)+" \n")
                f.write(rp_group+self.bit28.flop.name+" -column "+str(self.bit28.flop.x)+" -row "+str(self.bit28.flop.y)+" \n")
                f.write(rp_group+self.bit29.flop.name+" -column "+str(self.bit29.flop.x)+" -row "+str(self.bit29.flop.y)+" \n")
                f.write(rp_group+self.bit30.flop.name+" -column "+str(self.bit30.flop.x)+" -row "+str(self.bit30.flop.y)+" \n")
                f.write(rp_group+self.bit31.flop.name+" -column "+str(self.bit31.flop.x)+" -row "+str(self.bit31.flop.y)+" \n")
f = open('test.tcl','w')
f.write("create_rp_group rp1 -design nanorv32_pil -columns 32 -rows 32 \n")
rp_group_str = "add_to_rp_group nanorv32_pil::rp1 -leaf U_CPU/U_REG_FILE/"
temp = Register(0,0)
temp.printBits()
for i in range(0,32):
        temp = Register(i,i)
        temp.writeRpGroup(f,rp_group_str)
        f.write("\n")

f.close()

